//+------------------------------------------------------------------+
//|                                               Bars_MA.mq4        |
//|                                        Copyright  2012, FOX.RM  |
//|                                             fox.rm@mail.ru       |
//+------------------------------------------------------------------+

#property copyright "Copyright  2012, FOX.RM"
#property link      "http://www.niochem.net"


#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Tomato
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property indicator_level1 0
#property indicator_levelcolor Gray
#property indicator_levelstyle 2

extern int Period_MA = 5;
extern int MA_Line1 = 13;
extern int MA_Line2 = 34;
 
double Brs[],BrsMA1[],BrsMA2[],MathArr[],MathArr1;
int i=0,j=0;
double hvostUp,hvostDn,rast,S;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0,Brs);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Bars_");
   
   SetIndexBuffer(1,BrsMA1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"Bars_MA1");
   
   SetIndexBuffer(2,BrsMA2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"Bars_MA2");

   SetIndexBuffer(3,MathArr);     
   
 //---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Bars_MA");

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){return(0);}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start() {  

   int ncount=IndicatorCounted();
   int limit=Bars-ncount;

   for (int i=0; i<limit; i++)
   {
      S=0;
      rast=1;

      if (High[i+2]>High[i+1] && Low[i+2]>Low[i+1])
      {
         S=High[i+1]-Low[i+2];
         rast=High[i+2]-Low[i+1];

      } else if (High[i+2]<High[i+1] && Low[i+2]<Low[i+1])
      {
         S=High[i+2]-Low[i+1];
         rast=(High[i+1]-Low[i+2]);
      } else if (High[i+2]>=High[i+1] && Low[i+2]<=Low[i+1])
      {
         S=(High[i+1]-Low[i+1]);
         rast=(High[i+2]-Low[i+2]);
      } else if (High[i+2]<=High[i+1] && Low[i+2]>=Low[i+1])
      {
         S=(High[i+2]-Low[i+2]);
         rast=(High[i+1]-Low[i+1]);
      }
      MathArr[i]=0;
      if (rast!=0)  MathArr[i]=(S/rast*100);
   }
   for (i=0; i<limit; i++)
   {   
      Brs[i]    = iMAOnArray(MathArr,0, Period_MA,0,0,i);
      BrsMA1[i] = iMAOnArray(Brs,    0, MA_Line1,0,0,i);
      BrsMA2[i] = iMAOnArray(Brs,    0, MA_Line2,0,0,i);
   }   
   return(0);
}

